local VERSION = tonumber(("$Revision: 41261 $"):match("%d+"))

if uab.revision < VERSION then
	uab.version = "r" .. VERSION
	uab.revision = VERSION
	uab.date = ("$Date: 2007-06-22 08:09:07 -0400 (Fri, 22 Jun 2007) $"):match("%d%d%d%d%-%d%d%-%d%d")
end

local uabStatus_Aggro = uabUnitStatus:NewModule("Aggro", "AceEvent-2.0", "AceModuleCore-2.0")
uabStatus_Aggro:SetModuleMixins("Banzai-1.1")

uabStatus_Aggro.defaultDB = {
    disabled = nil,
    priority = 50,
    color = { r = 1,    g = 0,    b = 0, a = 1, },
    classfilter = {
        druid = true,
        hunter = true,
        mage = true,
        paladin = true,
        priest = true,
        rogue = true,
        shaman = true,
        warlock = true,
        warrior = true,
    },
}

function uabStatus_Aggro:OnInitialize()
    self.super.OnInitialize(self)

	self:RegisterUnitStatus(self.name)

	self:RegisterEvent("Banzai_UnitGainedAggro")
	self:RegisterEvent("Banzai_UnitLostAggro")
end

function uabStatus_Aggro:Banzai_UnitGainedAggro(unit)
    local class = self:GetUnitClass(unit)
    
    if not class or self.db.profile.classfilter[class] then
        self:UnitStatusGained(self.name, unit)
    end
end

function uabStatus_Aggro:Banzai_UnitLostAggro(unit)
    local class = self:GetUnitClass(unit)
    
    if not class or self.db.profile.classfilter[class] then
        self:UnitStatusLost(self.name, unit)
    end
end

function uabStatus_Aggro:OnEnable()
end

function uabStatus_Aggro:OnDisable()
end

function uabStatus_Aggro:IsStatusGained(name, unit, action)
	if name == self.name then
        local class = self:GetUnitClass(unit)
        
        if not class or self.db.profile.classfilter[class] then
    		return self:GetUnitAggroByUnitId(unit)
        end
	end
end

function uabStatus_Aggro:CreateUnitStatusOptions()
    return self:CreateUnitStatusOption(self.db.profile, "Aggro", "Aggro", true)
end
